﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Drawing;
using System.Windows;
using System.Windows.Data;
using System.Windows.Media;

namespace GridTest
{
    public class BackGroundConverter : System.Windows.DependencyObject, IValueConverter
    {
        public int RowIndex
        {
            get => System.Convert.ToInt32(GetValue(ExamplePropertyRow));
            set => SetValue(ExamplePropertyRow, value);
        }

        public int ColIndex
        {
            get => System.Convert.ToInt32(GetValue(ExamplePropertyCol));
            set => SetValue(ExamplePropertyCol, value);
        }

        public static readonly DependencyProperty ExamplePropertyRow =
            DependencyProperty.Register("RowIndex", typeof(int), typeof(BackGroundConverter), new PropertyMetadata(null));

        public static readonly DependencyProperty ExamplePropertyCol =
            DependencyProperty.Register("ColIndex", typeof(int), typeof(BackGroundConverter), new PropertyMetadata(null));

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var record = value as CellValuePresenter;

            if (record.Record.Index == RowIndex & record.Field.Index == ColIndex)
            {
                return new SolidColorBrush() { Color = System.Windows.Media.Colors.Yellow };
            }
            else
            {
                if (record.Field.Index == ColIndex)
                {
                    return new SolidColorBrush() { Color = System.Windows.Media.Colors.LimeGreen };
                }

                if (record.Record.Index == RowIndex)
                {
                    return new SolidColorBrush() { Color = System.Windows.Media.Colors.LimeGreen };
                }
            }

            return new SolidColorBrush() { Color = System.Windows.Media.Colors.Transparent };
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string strValue = value as string;
            double resultDouble;

            if (double.TryParse(strValue, out resultDouble))
            {
                return resultDouble;
            }
            return DependencyProperty.UnsetValue;
        }
    }
}