﻿using GridTest.ViewModel;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Timers;
using System.Windows;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Threading;
using System.Globalization;

namespace GridTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ApplicationViewModel ApplicationDataViewModel; //Session Data Context

        public List<GridData> matrixRowData;

        public MainWindow()
        {
            InitializeComponent();
            CreateData();
            ApplicationDataViewModel = (ApplicationViewModel)base.DataContext; //Set The DataContext
            ApplicationDataViewModel.PropertyChanged += ApplicationDataViewModel_PropertyChanged;
            testGrid.DataSource = matrixRowData;

            //System.Timers.Timer aTimer = new System.Timers.Timer();
            //aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
            //aTimer.Interval = 2500;
            //aTimer.Enabled = true;

            DispatcherTimer timer = new DispatcherTimer();
            timer.Interval = new TimeSpan(0,0,2);
            timer.Tick += Timer_Tick;
            timer.Start();
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            Random rand = new Random();
            ApplicationDataViewModel.ColIndex = rand.Next(0, 15);
            ApplicationDataViewModel.RowIndex = rand.Next(0, 15);
        }

        private void ApplicationDataViewModel_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "ColIndex")
            {

                Style style = this.Resources["CellGreenStyle"] as Style;
                foreach (Field f in testGrid.DefaultFieldLayout.Fields)
                {
                    if (f.CellValuePresenterStyle == style)
                    {
                        f.CellValuePresenterStyle = null;
                    }
                }
                testGrid.DefaultFieldLayout.Fields[ApplicationDataViewModel.ColIndex].CellValuePresenterStyle = style;
            }
        }

        public void CreateData()
        {
            byte[] bytes = new byte[256];

            for (int i = 0; i < 256; i++)
            {
                if (i == 1)
                {
                    bytes[i] = 15;
                }
                else
                {
                    bytes[i] = 0;
                }
            }

            int rowCounter = 16;
            int colCounter = 0;
            int index = 0;

            matrixRowData = new List<GridData>();
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());
            matrixRowData.Add(new GridData());

            foreach (byte b in bytes)
            {
                switch (colCounter)
                {
                    case 0:
                        matrixRowData[rowCounter - 1].Col1 = b;
                        break;
                    case 1:
                        matrixRowData[rowCounter - 1].Col2 = b;
                        break;
                    case 2:
                        matrixRowData[rowCounter - 1].Col3 = b;
                        break;
                    case 3:
                        matrixRowData[rowCounter - 1].Col4 = b;
                        break;
                    case 4:
                        matrixRowData[rowCounter - 1].Col5 = b;
                        break;
                    case 5:
                        matrixRowData[rowCounter - 1].Col6 = b;
                        break;
                    case 6:
                        matrixRowData[rowCounter - 1].Col7 = b;
                        break;
                    case 7:
                        matrixRowData[rowCounter - 1].Col8 = b;
                        break;
                    case 8:
                        matrixRowData[rowCounter - 1].Col9 = b;
                        break;
                    case 9:
                        matrixRowData[rowCounter - 1].Col10 = b;
                        break;
                    case 10:
                        matrixRowData[rowCounter - 1].Col11 = b;
                        break;
                    case 11:
                        matrixRowData[rowCounter - 1].Col12 = b;
                        break;
                    case 12:
                        matrixRowData[rowCounter - 1].Col13 = b;
                        break;
                    case 13:
                        matrixRowData[rowCounter - 1].Col14 = b;
                        break;
                    case 14:
                        matrixRowData[rowCounter - 1].Col15 = b;
                        break;
                    case 15:
                        matrixRowData[rowCounter - 1].Col16 = b;
                        break;
                }
                rowCounter--;

                if (rowCounter < 1)
                {
                    rowCounter = 16;
                    colCounter++;
                }

                index++;
            }
        }

        private void OnTimedEvent(object source, ElapsedEventArgs e)
        {
            //Random rand = new Random();
            //ApplicationDataViewModel.ColIndex = rand.Next(0, 15);
            //ApplicationDataViewModel.RowIndex = rand.Next(0, 15);
        }
    }

    public class RowStyleConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            int rowindex = (int)values[0];
            DataRecord row = values[1] as DataRecord;
            if (row != null)
            {
                if (row.Index == rowindex)
                {
                    return true;
                }
            }

            return false;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
