﻿using GridTest.View;
using System.ComponentModel;

namespace GridTest.ViewModel
{
    public class ApplicationViewModel : INotifyPropertyChanged
    {
        #region Constructor

        public ApplicationViewModel()
        {
            _Application = new Application
            {
                RowIndex = 5,
                ColIndex = 5
            };
        }

        #endregion

        #region Members

        Application _Application;

        #endregion

        #region Properties

        public Application Application
        {
            get { return _Application; }
            set { _Application = value; }
        }

        public int RowIndex
        {
            get { return Application.RowIndex; }
            set
            {
                if (Application.RowIndex != value)
                {
                    Application.RowIndex = value;
                    RaisePropertyChanged("RowIndex");
                }
            }
        }

        public int ColIndex
        {
            get { return Application.ColIndex; }
            set
            {
                if (Application.ColIndex != value)
                {
                    Application.ColIndex = value;
                    RaisePropertyChanged("ColIndex");
                }
            }
        }

        #endregion

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region Methods

        private void RaisePropertyChanged(string propertyName)
        {
            // take a copy to prevent thread issues
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}
